Gecode::Set::RelOp::UnionN< View0, View1 > Class Template Reference
Other available functionality » Set propagators

Propagator for nary union More...

`#include <rel-op.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function.
Public Member Functions inherited from Gecode::MixNaryOnePropagator< View0, PC_SET_ANY, View1, PC_SET_ANY >
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< View0 > &y, View1 x)
| Post propagator .
static ExecStatus | post (Home home, ViewArray< View0 > &y, const IntSet &z, View1 x)
| Post propagator .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| UnionN (Space &home, UnionN &p)
| Constructor for cloning p.
| UnionN (Home home, ViewArray< View0 > &, View1)
| Constructor for posting.
| UnionN (Home home, ViewArray< View0 > &, const IntSet &, View1)
| Constructor for posting.
Protected Member Functions inherited from Gecode::MixNaryOnePropagator< View0, PC_SET_ANY, View1, PC_SET_ANY >
| MixNaryOnePropagator (Space &home, MixNaryOnePropagator &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

bool | shared
| Whether the any views share a variable implementation.
GLBndSet | unionOfDets
| Union of the determined (which are dropped).
Protected Attributes inherited from Gecode::MixNaryOnePropagator< View0, PC_SET_ANY, View1, PC_SET_ANY >
ViewArray< View0 > | x
| Array of views.
View1 | y
| Single view.

## Detailed Description

template<class View0, class View1>
class Gecode::Set::RelOp::UnionN< View0, View1 >

Propagator for nary union

Requires

#include <gecode/set/rel-op.hh>
rel-op.hh

Definition at line 218 of file rel-op.hh.

## Constructor & Destructor Documentation

## UnionN() [1/3]

template<class View0, class View1>

Gecode::Set::RelOp::UnionN< View0, View1 >::UnionN | ( | Space & | home,
|  | UnionN< View0, View1 > & | p )

inline protected

Constructor for cloning p.

Definition at line 221 of file union.hpp.

## UnionN() [2/3]

template<class View0, class View1>

Gecode::Set::RelOp::UnionN< View0, View1 >::UnionN | ( | Home | home,
|  | ViewArray< View0 > & | x,
|  | View1 | y )

inline protected

Constructor for posting.

Definition at line 204 of file union.hpp.

## UnionN() [3/3]

template<class View0, class View1>

Gecode::Set::RelOp::UnionN< View0, View1 >::UnionN | ( | Home | home,
|  | ViewArray< View0 > & | x,
|  | const IntSet & | z,
|  | View1 | y )

inline protected

Constructor for posting.

Definition at line 211 of file union.hpp.

## Member Function Documentation

## copy()

template<class View0, class View1>

Actor * Gecode::Set::RelOp::UnionN< View0, View1 >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 229 of file union.hpp.

## propagate()

template<class View0, class View1>

ExecStatus Gecode::Set::RelOp::UnionN< View0, View1 >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 266 of file union.hpp.

## cost()

template<class View0, class View1>

PropCost Gecode::Set::RelOp::UnionN< View0, View1 >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function.

Reimplemented from Gecode::MixNaryOnePropagator< View0, PC_SET_ANY, View1, PC_SET_ANY >.

Definition at line 260 of file union.hpp.

## post() [1/2]

template<class View0, class View1>

ExecStatus Gecode::Set::RelOp::UnionN< View0, View1 >::post | ( | Home | home,
|  | ViewArray< View0 > & | y,
|  | View1 | x )

static

Post propagator .

Definition at line 235 of file union.hpp.

## post() [2/2]

template<class View0, class View1>

ExecStatus Gecode::Set::RelOp::UnionN< View0, View1 >::post | ( | Home | home,
|  | ViewArray< View0 > & | y,
|  | const IntSet & | z,
|  | View1 | x )

static

Post propagator .

Definition at line 252 of file union.hpp.

## Member Data Documentation

## shared

template<class View0, class View1>

bool Gecode::Set::RelOp::UnionN< View0, View1 >::shared

protected

Whether the any views share a variable implementation.

Definition at line 224 of file rel-op.hh.

## unionOfDets

template<class View0, class View1>

GLBndSet Gecode::Set::RelOp::UnionN< View0, View1 >::unionOfDets

protected

Union of the determined (which are dropped).

Definition at line 226 of file rel-op.hh.

The documentation for this class was generated from the following files:

- gecode/set/rel-op.hh
- gecode/set/rel-op/union.hpp